## ros-iron-ur-controllers 2.3.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(ur_controllers)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(angles REQUIRED)
find_package(controller_interface REQUIRED)
find_package(joint_trajectory_controller REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(pluginlib REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(rcutils REQUIRED)
find_package(realtime_tools REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)
find_package(ur_dashboard_msgs REQUIRED)
find_package(ur_msgs REQUIRED)
find_package(generate_parameter_library REQUIRED)

set(THIS_PACKAGE_INCLUDE_DEPENDS
  angles
  controller_interface
  joint_trajectory_controller
  lifecycle_msgs
  pluginlib
  rclcpp_lifecycle
  rcutils
  realtime_tools
  std_msgs
  std_srvs
  ur_dashboard_msgs
  ur_msgs
  generate_parameter_library
)

include_directories(include)


generate_parameter_library(
  gpio_controller_parameters
  src/gpio_controller_parameters.yaml
)

generate_parameter_library(
  speed_scaling_state_broadcaster_parameters
  src/speed_scaling_state_broadcaster_parameters.yaml
)

generate_parameter_library(
  scaled_joint_trajectory_controller_parameters
  src/scaled_joint_trajectory_controller_parameters.yaml
)

add_library(${PROJECT_NAME} SHARED
  src/scaled_joint_trajectory_controller.cpp
  src/speed_scaling_state_broadcaster.cpp
  src/gpio_controller.cpp)

target_include_directories(${PROJECT_NAME} PRIVATE
  include
)
target_link_libraries(${PROJECT_NAME}
  gpio_controller_parameters
  speed_scaling_state_broadcaster_parameters
  scaled_joint_trajectory_controller_parameters
)
ament_target_dependencies(${PROJECT_NAME}
  ${THIS_PACKAGE_INCLUDE_DEPENDS}
)

target_compile_options(${PROJECT_NAME} PRIVATE -Wpedantic -Werror=return-type)

# prevent pluginlib from using boost
target_compile_definitions(${PROJECT_NAME} PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
pluginlib_export_plugin_description_file(controller_interface controller_plugins.xml)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(DIRECTORY include/
  DESTINATION include
)

install(FILES controller_plugins.xml
  DESTINATION share/${PROJECT_NAME}
)

ament_export_dependencies(${THIS_PACKAGE_INCLUDE_DEPENDS})
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

ament_export_include_directories(
  include
)

ament_export_libraries(
  ${PROJECT_NAME}
)

ament_package()

=== debian/changelog ===
ros-iron-ur-controllers (2.3.3-1jammy) jammy; urgency=high

  * Handle api changes related to traj_external_point_ptr_ (#779 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/779>)
    * Handle api changes related to traj_external_point_ptr_
    * Fix formatting
    ---------
    Co-authored-by: Robert Wilbrandt <mailto:wilbrandt@fzi.de>
    (cherry picked from commit e2b22b15ca627cfb375c3d58e585e1d3dee5f484)
  * Contributors: Yadu

 -- Denis Stogl <denis@stoglrobotics.de>  Wed, 23 Aug 2023 00:00:00 -0000

ros-iron-ur-controllers (2.3.2-1jammy) jammy; urgency=high

  * added missing command interfaces into gpio controller (#693 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/693>)
  * Fixed formatting (#685 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/685>)
    * Removed empty lines from python files
    * Fixed typo in changelogs
  * Adding maximum retry counter in gpio controller (Multiarm part 3) - v2 (#672 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/672>)
  * Ported controllers to generate_parameters library and added prefix for controllers (Multiarm part 2) (#594 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/594>)
  * Switched out a deprecated header to avoid buildfarm warnings.
  * Introduce hand back control service (#528 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/528>)
  * Contributors: Felix Exner, Felix Exner (fexner), Lennart Nachtigall, livanov93

 -- Denis Stogl <denis@stoglrobotics.de>  Fri, 02 Jun 2023 00:00:00 -0000

ros-iron-ur-controllers (2.3.1-1jammy) jammy; urgency=high

  * Adjust scaled jtc to new publish_state interface
    Until next sync we need to build against upstream ros2_controllers, as
    this is an API-breaking change
  * Contributors: Robert Wilbrandt

 -- Denis Stogl <denis@stoglrobotics.de>  Thu, 16 Mar 2023 00:00:00 -0000

ros-iron-ur-controllers (2.3.0-1jammy) jammy; urgency=high

  * Added services to set tool voltage and zero force torque sensor (#466 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/466>)
    Added launch arguments for reverse ip and script command interface port.
  * Contributors: Mads Holm Peters

 -- Denis Stogl <denis@stoglrobotics.de>  Thu, 02 Mar 2023 00:00:00 -0000

ros-iron-ur-controllers (2.2.4-1jammy) jammy; urgency=high

  * Adapt jtc controller params to new param api
  * Contributors: Felix Exner

 -- Denis Stogl <denis@stoglrobotics.de>  Fri, 07 Oct 2022 00:00:00 -0000

ros-iron-ur-controllers (2.2.3-1jammy) jammy; urgency=high

  * Adapt ros control api (#448 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/448>)
    * scaled jtc: Use get_interface_name instead of get_name
    * Migrate from stopped controllers to inactive controllers
    stopped controllers has been deprecated upstream
  * Contributors: Felix Exner

 -- Denis Stogl <denis@stoglrobotics.de>  Wed, 27 Jul 2022 00:00:00 -0000

ros-iron-ur-controllers (2.2.2-1jammy) jammy; urgency=high

  * Adapted to JTC interpolation method feature (#439 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/439>)
  * Made sure all past maintainers are listed as authors (#429 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/429>)
  * Contributors: Felix Exner

 -- Denis Stogl <denis@stoglrobotics.de>  Tue, 19 Jul 2022 00:00:00 -0000

ros-iron-ur-controllers (2.2.1-1jammy) jammy; urgency=high



 -- Denis Stogl <denis@stoglrobotics.de>  Mon, 27 Jun 2022 00:00:00 -0000

ros-iron-ur-controllers (2.2.0-1jammy) jammy; urgency=high

  * Updated package maintainers
  * Prepare for humble (#394 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/394>)
  * Update dependencies on all packages (#391 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/391>)
  * Update controllers' API (#351 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/351>)
  * Update binary dependencies (#344 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/344>)
  * Use upstream fts_broadcaster (#304 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/304>)
  * Update license to BSD-3-Clause (#277 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/277>)
  * Added controller stopper node (#309 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/309>)
  * Add missing dependency on angles and update formatting for linters. (#283 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/283>)
  * Payload service (#238 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/238>)
  * Integration tests improvement (#206 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/206>)
  * Add resend program service and enable headless mode (#198 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/198>)
  * Update controllers adding dt in to update as in ros2_control (#171 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/171>)
  * Update main branch with ros-controls changes (#160 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/160>)
  * Update CI configuration to support galactic and rolling (#142 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/142>)
  * Modify parameter declaration - approach equalization with ros-controls dependencies (#152 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/152>)
  * Moved registering publisher and service to on_active (#151 <https://github.com/UniversalRobots/Universal_Robots_ROS2_Driver/issues/151>)
  * Correct formatting, include std::vector and update ros2_controller to master branch in repo file.
  * Correct check for fixed has_trajectory_msg()


=== debian/control ===
Source: ros-iron-ur-controllers
Section: misc
Priority: optional
Maintainer: Denis Stogl <denis@stoglrobotics.de>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake, ros-iron-angles, ros-iron-controller-interface, ros-iron-joint-trajectory-controller, ros-iron-lifecycle-msgs, ros-iron-pluginlib, ros-iron-rclcpp-lifecycle, ros-iron-rcutils, ros-iron-realtime-tools, ros-iron-std-msgs, ros-iron-std-srvs, ros-iron-ur-dashboard-msgs, ros-iron-ur-msgs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-ur-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-angles, ros-iron-controller-interface, ros-iron-joint-trajectory-controller, ros-iron-lifecycle-msgs, ros-iron-pluginlib, ros-iron-rclcpp-lifecycle, ros-iron-rcutils, ros-iron-realtime-tools, ros-iron-std-msgs, ros-iron-std-srvs, ros-iron-ur-dashboard-msgs, ros-iron-ur-msgs, ros-iron-ros-workspace
Description: Provides controllers that use the speed scaling interface of Universal Robots.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-ur-controllers//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
